case class Queue[A](in:List[A] = Nil, out:List[A] = Nil) {
    
    /** Ajoute un élément `x` en tête. */
    def enqueue(x:A):Queue[A] = this match {
        case Queue(Nil, h::t) => Queue(x::(h::t).reverse, Nil)
        case Queue(i, o) => Queue(x::i, o)
    }

    /** Retire le dernier élément. */
    //Peut ne pas fonctionner
    /**
    def dequeue():(A,Queue[A]) = this match {
        //cas bloquant
        case Queue(Nil, Nil) => sys.error("vilain effet de bord, faut corriger ça")
        
        case Queue(i, Nil) => {
            val rev = i.reverse
            (rev.head, Queue(Nil, rev.tail))
        }
        case Queue(Nil, o) => (o.head, Queue(Nil, o.tail))
    }
    **/

    //Fonctionnera
    def dequeue():(Option[A],Queue[A]) = this match {
        case Queue(Nil, Nil) => (None, Queue(Nil, Nil))
        case Queue(i, Nil) => {
            val rev = i.reverse
            (Some(rev.head), Queue(Nil, rev.tail))
        }
        case Queue(Nil, o) => (Some(o.head), Queue(Nil, o.tail))
    }

    /** Accès au premier élément, s'il existe. */
    def headOption():Option[A] = this match {
        case Queue(Nil, Nil) => None
        case Queue(Nil, o) => Some(o.reverse.head)
        case Queue(i, Nil) => Some(i.head)
    }

    /** Vrai si la liste est vide. */
    def isEmpty:Boolean = in.isEmpty && out.isEmpty
}